/*
**	$Id: EmulationPanel.c,v 1.7 92/08/15 20:12:39 olsen Sta Locker: olsen $
**	$Revision: 1.7 $
**	$Date: 92/08/15 20:12:39 $
**
**	Editing panel for emulation configuration
**
**	Copyright  1990-1992 by Olaf `Olsen' Barthel & MXM
**		All Rights Reserved
*/

#include "termGlobal.h"

enum	{	GAD_SMOOTHSCROLL,GAD_WRAPCHARS,GAD_WRAPCURSOR,GAD_INSERTMODE,GAD_NEWLINE,
		GAD_NUMKEYPAD,GAD_CURSORKEYS,GAD_FONTSCALE,GAD_USE,GAD_CANCEL };

STATIC STRPTR ControlMode[3] =
{
	NULL,
	NULL,
	NULL
};

STATIC STRPTR ScaleFontText[3] =
{
	NULL,
	NULL,
	NULL
};

STATIC struct Gadget *
CreateAllGadgets(struct Configuration *Config,struct Gadget *GadgetArray[],struct Gadget **GadgetList,APTR VisualInfo,UWORD TopEdge)
{
	struct Gadget		*Gadget;
	struct NewGadget	 NewGadget;
	UWORD			 Counter = 0;

	SZ_SizeSetup(Screen,&UserFont,TRUE);

	LocalizeString(ControlMode,MSG_EMULATIONPANEL_STANDARD_MODE_TXT,MSG_EMULATIONPANEL_APPLICATION_MODE_TXT);
	LocalizeString(ScaleFontText,MSG_EMULATIONPANEL_NORMAL_SCALE_TXT,MSG_EMULATIONPANEL_HALF_WIDTH_TXT);

	memset(&NewGadget,0,sizeof(struct NewGadget));

	if(Gadget = CreateContext(GadgetList))
	{
		SZ_AddLeftOffset(SZ_LeftOffsetDelta(MSG_EMULATIONPANEL_SMOOTH_SCROLLING_GAD,MSG_EMULATIONPANEL_FONT_SCALE_GAD));

		SZ_ResetMaxWidth();

		SZ_UpdateMaxWidth(CYCLE_KIND,NULL,0,ControlMode);
		SZ_UpdateMaxWidth(CYCLE_KIND,NULL,0,ScaleFontText);

		SZ_SetWidth(SZ_ResetMaxWidth());

		NewGadget . ng_GadgetText	= LocaleString(MSG_EMULATIONPANEL_SMOOTH_SCROLLING_GAD);
		NewGadget . ng_TextAttr		= &UserFont;
		NewGadget . ng_VisualInfo	= VisualInfo;
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(CHECKBOX_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,

			GT_Underscore,	'_',
			GTCB_Checked,	!Config -> JumpScroll,
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_EMULATIONPANEL_WRAP_CHARACTERS_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(CHECKBOX_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,

			GT_Underscore,	'_',
			GTCB_Checked,	Config -> AutoWrap,
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_EMULATIONPANEL_WRAP_CURSOR_MOVES_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(CHECKBOX_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,

			GT_Underscore,	'_',
			GTCB_Checked,	Config -> CursorWrap,
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_EMULATIONPANEL_INSERT_MODE_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(CHECKBOX_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,

			GT_Underscore,	'_',
			GTCB_Checked,	Config -> InsertChar,
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_EMULATIONPANEL_NEW_LINE_MODE_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(CHECKBOX_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,

			GT_Underscore,	'_',
			GTCB_Checked,	Config -> NewLine,
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_EMULATIONPANEL_NUMERIC_KEYPAD_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(CYCLE_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,

			GT_Underscore,	'_',
			GTCY_Labels,	ControlMode,
			GTCY_Active,	Config -> NumApp,
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_EMULATIONPANEL_CURSOR_KEYS_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(CYCLE_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,

			GT_Underscore,	'_',
			GTCY_Labels,	ControlMode,
			GTCY_Active,	Config -> CursorApp,
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_EMULATIONPANEL_FONT_SCALE_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(CYCLE_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,

			GT_Underscore,	'_',
			GTCY_Labels,	ScaleFontText,
			GTCY_Active,	Config -> FontScale,
		TAG_DONE);

		SZ_UpdateMaxWidth(BUTTON_KIND,LocaleString(MSG_GLOBAL_USE_GAD),0,NULL);
		SZ_UpdateMaxWidth(BUTTON_KIND,LocaleString(MSG_GLOBAL_CANCEL_GAD),0,NULL);

		SZ_SetWidth(SZ_ResetMaxWidth());

		NewGadget . ng_GadgetText	= LocaleString(MSG_GLOBAL_USE_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(BUTTON_KIND,Gadget,&NewGadget,
			SZ_AlignExtra,	TRUE,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,
			SZ_AlignLeft,	TRUE,

			GT_Underscore,	'_',
		TAG_DONE);

		NewGadget . ng_GadgetText	= LocaleString(MSG_GLOBAL_CANCEL_GAD);
		NewGadget . ng_GadgetID		= Counter;

		GadgetArray[Counter++] = Gadget = CreateGadget(BUTTON_KIND,Gadget,&NewGadget,
			SZ_Adjust,	TRUE,
			SZ_AutoWidth,	TRUE,
			SZ_AlignRight,	TRUE,

			GT_Underscore,	'_',
		TAG_DONE);
	}

	return(Gadget);
}

VOID
EmulationPanel(struct Configuration *Config)
{
	struct Window	*PanelWindow;
	struct Gadget	*GadgetList;
	struct Gadget	*GadgetArray[GAD_CANCEL + 1];

	ClearCursor();

	CopyMem(Config,&PrivateConfig,sizeof(struct Configuration));

	if(CreateAllGadgets(Config,&GadgetArray[0],&GadgetList,VisualInfo,Screen -> WBorTop + Screen -> Font -> ta_YSize + 1))
	{
		if(PanelWindow = OpenWindowTags(NULL,
			WA_Left,	(Screen -> Width	- SZ_GetWindowWidth())	/ 2,
			WA_Top,		(Screen -> Height	- SZ_GetWindowHeight())	/ 2,
			WA_Width,	SZ_GetWindowWidth(),
			WA_Height,	SZ_GetWindowHeight(),

			WA_Activate,	TRUE,
			WA_DragBar,	TRUE,
			WA_DepthGadget,	TRUE,
			WA_RMBTrap,	TRUE,
			WA_DepthGadget,	TRUE,
			WA_CloseGadget,	TRUE,
			WA_CustomScreen,Screen,
			WA_IDCMP,	IDCMP_CLOSEWINDOW | IDCMP_VANILLAKEY | CHECKBOXIDCMP | CYCLEIDCMP,
			WA_Title,	LocaleString(MSG_EMULATIONPANEL_EMULATION_PREFERENCES_TXT),
		TAG_DONE))
		{
			struct IntuiMessage	*Massage;
			ULONG			 Class,Code;
			struct Gadget		*Gadget;
			BYTE			 Terminated = FALSE;

			PushWindow(PanelWindow);

			AddGList(PanelWindow,GadgetList,(UWORD)-1,(UWORD)-1,NULL);
			RefreshGList(GadgetList,PanelWindow,NULL,(UWORD)-1);
			GT_RefreshWindow(PanelWindow,NULL);

			while(!Terminated)
			{
				WaitPort(PanelWindow -> UserPort);

				while(!Terminated && (Massage = (struct IntuiMessage *)GT_GetIMsg(PanelWindow -> UserPort)))
				{
					Class	= Massage -> Class;
					Code	= Massage -> Code;
					Gadget	= (struct Gadget *)Massage -> IAddress;

					GT_ReplyIMsg(Massage);

					if(Class == IDCMP_VANILLAKEY)
						KeySelect(GadgetArray,GAD_CANCEL,Code,PanelWindow,&Gadget,&Class,&Code);

					if(Class == IDCMP_CLOSEWINDOW)
						Terminated = TRUE;

GadCheck:				if(Class == IDCMP_GADGETUP)
					{
						switch(Gadget -> GadgetID)
						{
							case GAD_USE:		Terminated = TRUE;

										Config -> JumpScroll	= !GT_CHECKED(GadgetArray[GAD_SMOOTHSCROLL]);
										Config -> AutoWrap	= GT_CHECKED(GadgetArray[GAD_WRAPCHARS]);
										Config -> CursorWrap	= GT_CHECKED(GadgetArray[GAD_WRAPCURSOR]);
										Config -> InsertChar	= GT_CHECKED(GadgetArray[GAD_INSERTMODE]);
										Config -> NewLine	= GT_CHECKED(GadgetArray[GAD_NEWLINE]);

										break;

							case GAD_CANCEL:	Terminated = TRUE;

										CopyMem(&PrivateConfig,Config,sizeof(struct Configuration));

										break;

							case GAD_NUMKEYPAD:	Config -> NumApp = Code;
										break;

							case GAD_CURSORKEYS:	Config -> CursorApp = Code;
										break;

							case GAD_FONTSCALE:	Config -> FontScale = Code;
										break;

							default:		break;
						}
					}
				}
			}

			RemoveGList(PanelWindow,GadgetList,(UWORD)-1);

			PopWindow();

			CloseWindow(PanelWindow);
		}

		FreeGadgets(GadgetList);
	}

	if(PrivateConfig . FontScale == SCALE_HALF && Config -> FontScale != SCALE_HALF)
	{
		if(Config -> EightyColumns)
		{
			LastColumn	= 79;
			LastPixel	= 80 * 8 - 1;
		}
		else
		{
			LastColumn	= Window -> Width / TextFontWidth - 1;
			LastPixel	= (LastColumn + 1) * TextFontWidth - 1;
		}
	}

	if(PrivateConfig . FontScale != SCALE_HALF && Config -> FontScale == SCALE_HALF)
	{
		if(Config -> EightyColumns)
		{
			LastColumn	= 131;
			LastPixel	= 80 * 8 - 1;
		}
		else
		{
			LastColumn	= Window -> Width / (TextFontWidth / 2) - 1;
			LastPixel	= (LastColumn + 1) * (TextFontWidth / 2) - 1;
		}
	}

	SetCursor();
}
